/* -*- mode:prolog; -*-
 ******************************************************************
 * $Id: tfs.pl 225 2001-11-12 16:09:37Z clerger $
 * Copyright (C) 1998 by INRIA 
 * Author: Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>
 * ----------------------------------------------------------------
 *
 *  tfs.pl -- Type Feature Structures
 *
 * ----------------------------------------------------------------
 * Description
 * 
 * ----------------------------------------------------------------
 */


:-include 'header.pl'.
:-require 'reader.pl', 'checker.pl', 'emit.pl'.


?-wait(compile),
  ( recorded_answer(compile) ->
      exit(0)
  ;
      error( 'internal error using tfs', [] )
  )
  .

compile :-
	op( 500, xfy, [sub,intro,escape]),
	argv( Argv ),
	phrase( parse_options, Argv, [] ),
	checker,
	emit
	.

:-prolog (dcg parse_options/0, parse_option/0).

parse_options --> parse_option, parse_options ; [].
parse_option -->
	( ['-f',File] -> { record(tfs_file(File)), reader(File) }
	; ['-o',File] -> { record( output_file(File) ) }
	;   ['-I',Path] -> { add_load_path(Path) }
	; [File] -> { record( tfs_file(File) ), reader(File) }
	;   { fail }
	)
	.

%% Internal Special Types
%% To use them, they should be inserted in the hierarchy
%% but they should be maximun and not associated with any features

r_tfs_escape('compound').    %% Escape to any Prolog compound (not deref)
r_tfs_escape('symbol').
r_tfs_escape('integer').
r_tfs_escape('char').












